-- Local initialisations
Nanika = LibStub("AceAddon-3.0"):NewAddon("Nanika", "AceEvent-3.0", "AceTimer-3.0")
local settings = {}

-- Ace functions
function Nanika:OnInitialize()
	local dbsettings = { profile = settings }
	self.db = LibStub("AceDB-3.0"):New("NanikaDB", dbsettings, true)
	settings = self.db.profile
	--Set up configuration screen
	--Set up slash commands
end
function Nanika:OnEnable()
end
function Nanika:OnDisable()
end
-- Chat helpers
function Nanika:SW(msg)
	--SendChatMessage(msg, "WHISPER", nil, UnitName("player"))
end
function Nanika:PC(msg)
	if IsInGroup(LE_PARTY_CATEGORY_HOME) then SendChatMessage(msg, "PARTY") return end
	self:SW(msg)
end
function Nanika:GC(msg)
	if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then SendChatMessage(msg, "INSTANCE_CHAT") return end
	self:PC(msg)
end
function Nanika:RC(msg)
	if IsInRaid() then SendChatMessage(msg, "RAID") return end
	self:GC(msg)
end
function Nanika:RW(msg)
	if UnitIsRaidOfficer("player") then SendChatMessage(msg ,"RAID_WARNING") return end
	self:RC(msg)
end
-- Player helpers
function Nanika:GetClass()
	local _, class = UnitClass("player")
	return class
end
-- Group/Raid helpers
function Nanika:GetRaidLayout()
	if not IsInGroup() then return nil end
	local raid = {}
	raid["TANK"] = { MemberCount = 0, Members = {} }
	raid["HEALER"] = { MemberCount = 0, Members = {} }
	raid["DAMAGER"] = { MemberCount = 0, Members = {} }
	raid["NONE"] = { MemberCount = 0, Members = {} }
	for i = 1, MAX_RAID_GROUPS do raid[i] = { MemberCount = 0, Members = {} } end
	if IsInRaid() then
		for i = 1, GetNumGroupMembers() do
			name,_,subgroup = GetRaidRosterInfo(i)
			raid[subgroup].MemberCount = raid[subgroup].MemberCount + 1
			table.insert(raid[subgroup].Members, { Name = name, UnitId = "raid"..i })
			role = UnitGroupRolesAssigned(name)
			if role then
				table.insert(raid[role].Members, { Name = name, UnitId = "raid"..i })
				raid[role].MemberCount = raid[role].MemberCount + 1
			end
		end
	else
		raid[1].MemberCount = GetNumGroupMembers()
		for i = 1, raid[1].MemberCount do
			name = GetRaidRosterInfo(i)
			table.insert(raid[1].Members, { Name = name, UnitId = "party"..i })
			role = UnitGroupRolesAssigned(name)
			if role then
				table.insert(raid[role].Members, { Name = name, UnitId = "party"..i })
				raid[role].MemberCount = raid[role].MemberCount + 1
			end
		end
	end
	return raid
end

-- Blizz future UI?
if not UIDropDownMenu_AddSeparator then
function UIDropDownMenu_AddSeparator(info, level)
	info.text = nil;
	info.dist = 0;
	info.isTitle = true;
	info.isUninteractable = true;
	info.notCheckable = true;
	info.iconOnly = true;
	info.icon = "Interface\\Common\\UI-TooltipDivider-Transparent";
	info.tCoordLeft = 0;
	info.tCoordRight = 1;
	info.tCoordTop = 0;
	info.tCoordBottom = 1;
	info.tSizeX = 0;
	info.tSizeY = 8;
	info.tFitDropDownSizeX = true;
	info.iconInfo = { tCoordLeft = info.tCoordLeft,
							tCoordRight = info.tCoordRight,
							tCoordTop = info.tCoordTop,
							tCoordBottom = info.tCoordBottom,
							tSizeX = info.tSizeX,
							tSizeY = info.tSizeY,
							tFitDropDownSizeX = info.tFitDropDownSizeX };

	UIDropDownMenu_AddButton(info, level);
end
end